Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/SelfTest/src/test.cpp	(revision 88)
@@ -24,4 +24,14 @@
 #endif
 
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+//   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
   Address_management * _Address_management = new Address_management 
     (name.c_str(),
@@ -30,5 +40,5 @@
 #endif
      _param,
-     USE_ALL);
+     _usage);
   
 #ifdef SYSTEMC
@@ -62,4 +72,7 @@
   ALLOC_SC_SIGNAL (out_EVENT_ACK                          ,"out_EVENT_ACK                          ",Tcontrol_t        );
   ALLOC_SC_SIGNAL ( in_EVENT_ADDRESS                      ," in_EVENT_ADDRESS                      ",Tgeneral_address_t);
+  ALLOC_SC_SIGNAL ( in_EVENT_ADDRESS_NEXT                 ," in_EVENT_ADDRESS_NEXT                 ",Tgeneral_address_t);
+  ALLOC_SC_SIGNAL ( in_EVENT_ADDRESS_NEXT_VAL             ," in_EVENT_ADDRESS_NEXT_VAL             ",Tcontrol_t        );
+  ALLOC_SC_SIGNAL ( in_EVENT_IS_DS_TAKE                   ," in_EVENT_IS_DS_TAKE                   ",Tcontrol_t        );
   
   /********************************************************
@@ -76,8 +89,8 @@
   INSTANCE_SC_SIGNAL (_Address_management,out_ADDRESS_INSTRUCTION_ADDRESS        );
   INSTANCE1_SC_SIGNAL(_Address_management,out_ADDRESS_INSTRUCTION_ENABLE         ,_param->_nb_instruction);
-  if (_param->_have_port_instruction_ptr)
+  if (_param->_have_port_inst_ifetch_ptr)
   INSTANCE_SC_SIGNAL (_Address_management,out_ADDRESS_INST_IFETCH_PTR            );
   INSTANCE_SC_SIGNAL (_Address_management,out_ADDRESS_BRANCH_STATE               );
-  if (_param->_have_port_branch_update_prediction_id)
+  if (_param->_have_port_depth)
   INSTANCE_SC_SIGNAL (_Address_management,out_ADDRESS_BRANCH_UPDATE_PREDICTION_ID);
   INSTANCE_SC_SIGNAL (_Address_management,out_PREDICT_VAL                        );
@@ -89,12 +102,15 @@
   INSTANCE_SC_SIGNAL (_Address_management, in_PREDICT_PC_NEXT_IS_DS_TAKE         );
   INSTANCE1_SC_SIGNAL(_Address_management, in_PREDICT_INSTRUCTION_ENABLE         ,_param->_nb_instruction);
-  if (_param->_have_port_instruction_ptr)
+  if (_param->_have_port_inst_ifetch_ptr)
   INSTANCE_SC_SIGNAL (_Address_management, in_PREDICT_INST_IFETCH_PTR            );
   INSTANCE_SC_SIGNAL (_Address_management, in_PREDICT_BRANCH_STATE               );
-  if (_param->_have_port_branch_update_prediction_id)
+  if (_param->_have_port_depth)
   INSTANCE_SC_SIGNAL (_Address_management, in_PREDICT_BRANCH_UPDATE_PREDICTION_ID);
   INSTANCE_SC_SIGNAL (_Address_management, in_EVENT_VAL                          );
   INSTANCE_SC_SIGNAL (_Address_management,out_EVENT_ACK                          );
   INSTANCE_SC_SIGNAL (_Address_management, in_EVENT_ADDRESS                      );
+  INSTANCE_SC_SIGNAL (_Address_management, in_EVENT_ADDRESS_NEXT                 );
+  INSTANCE_SC_SIGNAL (_Address_management, in_EVENT_ADDRESS_NEXT_VAL             );
+  INSTANCE_SC_SIGNAL (_Address_management, in_EVENT_IS_DS_TAKE                   );
 
   msg(_("<%s> : Start Simulation ............\n"),name.c_str());
@@ -143,7 +159,7 @@
   Tcontrol_t      nn_val  = false;
 
-  Tgeneral_data_t c_addr  = 0x100;
-  Tgeneral_data_t n_addr  = 0x100;
-  Tgeneral_data_t nn_addr = 0x100;
+  Tgeneral_data_t c_addr  = 0x100>>2;
+  Tgeneral_data_t n_addr  = 0x100>>2;
+  Tgeneral_data_t nn_addr = 0x100>>2;
 
   Tcontrol_t      c_enable [_param->_nb_instruction];
@@ -159,11 +175,14 @@
 
   LABEL("Send Reset");
-  do 
-    {
-      in_EVENT_VAL    ->write(1);
-      in_EVENT_ADDRESS->write(n_addr);
-      SC_START(1);  
-    } while (out_EVENT_ACK->read() == false);
-  in_EVENT_VAL    ->write(0);
+//   do 
+//     {
+//       in_EVENT_VAL             ->write(1);
+//       in_EVENT_ADDRESS         ->write(n_addr);
+//       in_EVENT_ADDRESS_NEXT    ->write(nn_addr);
+//       in_EVENT_ADDRESS_NEXT_VAL->write(0);
+//       in_EVENT_IS_DS_TAKE      ->write(0);
+//       SC_START(1);  
+//     } while (out_EVENT_ACK->read() == false);
+//   in_EVENT_VAL    ->write(0);
 
   n_val = 1;
@@ -206,6 +225,10 @@
       }
 
-      in_EVENT_VAL    ->write((rand()%100)<percent_transaction_event  );
-      in_EVENT_ADDRESS->write(0x100);
+      in_EVENT_VAL             ->write((rand()%100)<percent_transaction_event  );
+      in_EVENT_ADDRESS         ->write(0x77);
+      in_EVENT_ADDRESS_NEXT    ->write(0x171);
+      Tcontrol_t next_val = rand()%2;
+      in_EVENT_ADDRESS_NEXT_VAL->write(next_val);
+      in_EVENT_IS_DS_TAKE      ->write(next_val);
 
       //-------------------------------------------------
@@ -238,8 +261,8 @@
 	  for (uint32_t i=0; i<_param->_nb_instruction; i++)
 	  TEST(Tcontrol_t        ,out_ADDRESS_INSTRUCTION_ENABLE     [i] ->read(),c_enable[i]);
-	  if (_param->_have_port_instruction_ptr)
+	  if (_param->_have_port_inst_ifetch_ptr)
 	  TEST(Tinst_ifetch_ptr_t,out_ADDRESS_INST_IFETCH_PTR            ->read(),0);
 	  TEST(Tbranch_state_t   ,out_ADDRESS_BRANCH_STATE               ->read(),0);
-	  if (_param->_have_port_branch_update_prediction_id)
+	  if (_param->_have_port_depth)
 	  TEST(Tprediction_ptr_t ,out_ADDRESS_BRANCH_UPDATE_PREDICTION_ID->read(),0);
 
@@ -272,14 +295,17 @@
 	  LABEL("EVENT      : Transaction accepted");
 
-	  c_val           = false;
-	  n_val           = true;
-	  nn_val          = false;
-
-	  n_addr         = in_EVENT_ADDRESS->read();
-	  n_is_ds_take   = 0;
+	  c_val        = false;
+	  n_val        = true;
+	  n_addr       = in_EVENT_ADDRESS         ->read();
+	  n_is_ds_take = in_EVENT_IS_DS_TAKE      ->read();
+	  nn_val       = in_EVENT_ADDRESS_NEXT_VAL->read();
+          nn_addr      = in_EVENT_ADDRESS_NEXT    ->read();
+          nn_is_ds_take= false;
+//           nn_val = false;
+//           n_is_ds_take = 0;
 
 	  n_enable [0] = 1;
-	  for (uint32_t i=1; i<_param->_nb_instruction; i++)
-	    n_enable [i] = 0;
+          for (uint32_t i=1; i<_param->_nb_instruction; i++)
+            n_enable [i] = 0;
 	}
 
@@ -347,4 +373,7 @@
   delete    out_EVENT_ACK                          ;
   delete     in_EVENT_ADDRESS                      ;
+  delete     in_EVENT_ADDRESS_NEXT                 ;
+  delete     in_EVENT_ADDRESS_NEXT_VAL             ;
+  delete     in_EVENT_IS_DS_TAKE                   ;
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/include/Address_management.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/include/Address_management.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/include/Address_management.h	(revision 88)
@@ -91,4 +91,7 @@
   public    : SC_OUT(Tcontrol_t        )    * out_EVENT_ACK                           ;
   public    : SC_IN (Tgeneral_address_t)    *  in_EVENT_ADDRESS                       ;
+  public    : SC_IN (Tgeneral_address_t)    *  in_EVENT_ADDRESS_NEXT                  ;
+  public    : SC_IN (Tcontrol_t        )    *  in_EVENT_ADDRESS_NEXT_VAL              ;
+  public    : SC_IN (Tcontrol_t        )    *  in_EVENT_IS_DS_TAKE                    ;
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/include/Parameters.h	(revision 88)
@@ -24,19 +24,22 @@
     //-----[ fields ]------------------------------------------------------------
   public : uint32_t _nb_instruction               ;
-  public : uint32_t _size_address                 ;
-  public : uint32_t _size_branch_update_prediction;
+//public : uint32_t _size_address                 ;
+//public : uint32_t _size_branch_update_prediction;
 
-  public : uint32_t _size_instruction_ptr                 ;
-
-  public : bool     _have_port_instruction_ptr            ;
-  public : bool     _have_port_branch_update_prediction_id;
+//public : uint32_t _size_instruction_ptr                 ;
+//
+//public : bool     _have_port_instruction_ptr            ;
+//public : bool     _have_port_branch_update_prediction_id;
 
     //-----[ methods ]-----------------------------------------------------------
   public : Parameters  (uint32_t nb_instruction,
 			uint32_t size_address  ,
-			uint32_t size_branch_update_prediction);
+			uint32_t size_branch_update_prediction,
+                        bool     is_toplevel=false);
 
 //   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
+
+  public :        void            copy       (void);
 
   public :        Parameters_test msg_error  (void);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management.cpp	(revision 88)
@@ -38,4 +38,10 @@
     log_printf(FUNC,Address_management,FUNCTION,"Begin");
 
+#if DEBUG_Address_management == true
+    log_printf(INFO,Address_management,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
     log_printf(INFO,Address_management,FUNCTION,"Allocation");
 
@@ -47,5 +53,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {	
 	log_printf(INFO,Address_management,FUNCTION,"Allocation of statistics");
@@ -56,5 +62,5 @@
 
 #ifdef VHDL
-    if (_usage & USE_VHDL)
+    if (usage_is_set(_usage,USE_VHDL))
       {
 	// generate the vhdl
@@ -66,5 +72,5 @@
 
 #ifdef SYSTEMC
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	// Affect output constant
@@ -94,4 +100,5 @@
 #endif
       }
+
     log_printf(FUNC,Address_management,FUNCTION,"End");
   };
@@ -104,5 +111,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {
 	statistics_deallocation();
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_allocation.cpp	(revision 88)
@@ -62,8 +62,8 @@
       ALLOC_VALACK_OUT (out_ADDRESS_VAL                        ,VAL);
       ALLOC_VALACK_IN  ( in_ADDRESS_ACK                        ,ACK);
-      ALLOC_SIGNAL_OUT (out_ADDRESS_INSTRUCTION_ADDRESS        ,"instruction_address"        ,Tgeneral_address_t,_param->_size_address                 );
-      ALLOC_SIGNAL_OUT (out_ADDRESS_INST_IFETCH_PTR            ,"inst_ifetch_ptr"            ,Tinst_ifetch_ptr_t,_param->_size_instruction_ptr         );
+      ALLOC_SIGNAL_OUT (out_ADDRESS_INSTRUCTION_ADDRESS        ,"instruction_address"        ,Tgeneral_address_t,_param->_size_instruction_address     );
+      ALLOC_SIGNAL_OUT (out_ADDRESS_INST_IFETCH_PTR            ,"inst_ifetch_ptr"            ,Tinst_ifetch_ptr_t,_param->_size_inst_ifetch_ptr         );
       ALLOC_SIGNAL_OUT (out_ADDRESS_BRANCH_STATE               ,"branch_state"               ,Tbranch_state_t   ,_param->_size_branch_state            );
-      ALLOC_SIGNAL_OUT (out_ADDRESS_BRANCH_UPDATE_PREDICTION_ID,"branch_update_prediction_id",Tprediction_ptr_t ,_param->_size_branch_update_prediction);
+      ALLOC_SIGNAL_OUT (out_ADDRESS_BRANCH_UPDATE_PREDICTION_ID,"branch_update_prediction_id",Tprediction_ptr_t ,_param->_size_depth);
     }
 
@@ -80,12 +80,12 @@
       ALLOC_VALACK_OUT (out_PREDICT_VAL                        ,VAL);
       ALLOC_VALACK_IN  ( in_PREDICT_ACK                        ,ACK);
-      ALLOC_SIGNAL_OUT (out_PREDICT_PC_PREVIOUS                ,"pc_previous"                ,Tgeneral_address_t,_param->_size_address);
-      ALLOC_SIGNAL_OUT (out_PREDICT_PC_CURRENT                 ,"pc_current"                 ,Tgeneral_address_t,_param->_size_address);
+      ALLOC_SIGNAL_OUT (out_PREDICT_PC_PREVIOUS                ,"pc_previous"                ,Tgeneral_address_t,_param->_size_instruction_address);
+      ALLOC_SIGNAL_OUT (out_PREDICT_PC_CURRENT                 ,"pc_current"                 ,Tgeneral_address_t,_param->_size_instruction_address);
       ALLOC_SIGNAL_OUT (out_PREDICT_PC_CURRENT_IS_DS_TAKE      ,"pc_current_is_ds_take"      ,Tcontrol_t        ,1);
-      ALLOC_SIGNAL_IN  ( in_PREDICT_PC_NEXT                    ,"pc_next"                    ,Tgeneral_address_t,_param->_size_address);
+      ALLOC_SIGNAL_IN  ( in_PREDICT_PC_NEXT                    ,"pc_next"                    ,Tgeneral_address_t,_param->_size_instruction_address);
       ALLOC_SIGNAL_IN  ( in_PREDICT_PC_NEXT_IS_DS_TAKE         ,"pc_next_is_ds_take"         ,Tcontrol_t        ,1);
-      ALLOC_SIGNAL_IN  ( in_PREDICT_INST_IFETCH_PTR            ,"inst_ifetch_ptr"            ,Tinst_ifetch_ptr_t,_param->_size_instruction_ptr);
+      ALLOC_SIGNAL_IN  ( in_PREDICT_INST_IFETCH_PTR            ,"inst_ifetch_ptr"            ,Tinst_ifetch_ptr_t,_param->_size_inst_ifetch_ptr);
       ALLOC_SIGNAL_IN  ( in_PREDICT_BRANCH_STATE               ,"branch_state"               ,Tbranch_state_t   ,_param->_size_branch_state);
-      ALLOC_SIGNAL_IN  ( in_PREDICT_BRANCH_UPDATE_PREDICTION_ID,"branch_update_prediction_id",Tprediction_ptr_t ,_param->_size_branch_update_prediction);
+      ALLOC_SIGNAL_IN  ( in_PREDICT_BRANCH_UPDATE_PREDICTION_ID,"branch_update_prediction_id",Tprediction_ptr_t ,_param->_size_depth);
     }
     {
@@ -99,15 +99,23 @@
       ALLOC_INTERFACE("event", IN, SOUTH, "Event (miss, exception ...)");
 
-      ALLOC_VALACK_IN ( in_EVENT_VAL    ,VAL);
-      ALLOC_VALACK_OUT(out_EVENT_ACK    ,ACK);
-      ALLOC_SIGNAL_IN ( in_EVENT_ADDRESS,"address",Tgeneral_address_t,_param->_size_address);
+      ALLOC_VALACK_IN ( in_EVENT_VAL          ,VAL);
+      ALLOC_VALACK_OUT(out_EVENT_ACK          ,ACK);
+      ALLOC_SIGNAL_IN ( in_EVENT_ADDRESS         ,"address"         ,Tgeneral_address_t,_param->_size_instruction_address);
+      ALLOC_SIGNAL_IN ( in_EVENT_ADDRESS_NEXT    ,"address_next"    ,Tgeneral_address_t,_param->_size_instruction_address);
+      ALLOC_SIGNAL_IN ( in_EVENT_ADDRESS_NEXT_VAL,"address_next_val",Tcontrol_t,1);
+      ALLOC_SIGNAL_IN ( in_EVENT_IS_DS_TAKE      ,"is_ds_take"      ,Tcontrol_t,1);
     }
 
+    // ~~~~~[ Internal  ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+        reg_PC_CURRENT_INSTRUCTION_ENABLE = new Tcontrol_t [_param->_nb_instruction];
+        reg_PC_NEXT_INSTRUCTION_ENABLE    = new Tcontrol_t [_param->_nb_instruction];
+      }
+
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-    reg_PC_CURRENT_INSTRUCTION_ENABLE = new Tcontrol_t [_param->_nb_instruction];
-    reg_PC_NEXT_INSTRUCTION_ENABLE    = new Tcontrol_t [_param->_nb_instruction];
-
 #ifdef POSITION
-    _component->generate_file();
+     if (usage_is_set(_usage,USE_POSITION))
+       _component->generate_file();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_deallocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_deallocation.cpp	(revision 88)
@@ -23,5 +23,5 @@
     log_printf(FUNC,Address_management,FUNCTION,"Begin");
 
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	delete    in_CLOCK ;
@@ -32,8 +32,8 @@
 	delete    out_ADDRESS_INSTRUCTION_ADDRESS        ;
 	delete [] out_ADDRESS_INSTRUCTION_ENABLE         ;
-	if (_param->_have_port_instruction_ptr)
+	if (_param->_have_port_inst_ifetch_ptr)
 	delete    out_ADDRESS_INST_IFETCH_PTR            ;
 	delete    out_ADDRESS_BRANCH_STATE               ;
-	if (_param->_have_port_branch_update_prediction_id)
+	if (_param->_have_port_depth)
 	delete    out_ADDRESS_BRANCH_UPDATE_PREDICTION_ID;
 	delete    out_PREDICT_VAL                        ;
@@ -45,17 +45,24 @@
 	delete     in_PREDICT_PC_NEXT_IS_DS_TAKE         ;
 	delete []  in_PREDICT_INSTRUCTION_ENABLE         ;
-	if (_param->_have_port_instruction_ptr)
+	if (_param->_have_port_inst_ifetch_ptr)
 	delete     in_PREDICT_INST_IFETCH_PTR            ;
 	delete     in_PREDICT_BRANCH_STATE               ;
-	if (_param->_have_port_branch_update_prediction_id)
+	if (_param->_have_port_depth)
 	delete     in_PREDICT_BRANCH_UPDATE_PREDICTION_ID;
 	delete     in_EVENT_VAL                          ;
 	delete    out_EVENT_ACK                          ;
 	delete     in_EVENT_ADDRESS                      ;
+	delete     in_EVENT_ADDRESS_NEXT                 ;
+	delete     in_EVENT_ADDRESS_NEXT_VAL             ;
+	delete     in_EVENT_IS_DS_TAKE                   ;
+      
+        // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+        if (usage_is_set(_usage,USE_SYSTEMC))
+          {
+            delete reg_PC_CURRENT_INSTRUCTION_ENABLE;
+            delete reg_PC_NEXT_INSTRUCTION_ENABLE   ;
+          }
       }
 
-    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-    delete reg_PC_CURRENT_INSTRUCTION_ENABLE;
-    delete reg_PC_NEXT_INSTRUCTION_ENABLE   ;
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_end_cycle.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_end_cycle.cpp	(revision 88)
@@ -25,5 +25,6 @@
 
 #ifdef STATISTICS
-    _stat->end_cycle();
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
 #endif    
 
@@ -31,5 +32,6 @@
     // Evaluation before read the ouput signal
 //  sc_start(0);
-    _interfaces->testbench();
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_genMoore.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_genMoore.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_genMoore.cpp	(revision 88)
@@ -32,8 +32,8 @@
     PORT_WRITE(out_ADDRESS_VAL                        ,internal_ADDRESS_VAL                      );
     PORT_WRITE(out_ADDRESS_INSTRUCTION_ADDRESS        ,reg_PC_CURRENT                            );
-    if (_param->_have_port_instruction_ptr)
+    if (_param->_have_port_inst_ifetch_ptr)
     PORT_WRITE(out_ADDRESS_INST_IFETCH_PTR            ,reg_PC_CURRENT_INST_IFETCH_PTR            );
     PORT_WRITE(out_ADDRESS_BRANCH_STATE               ,reg_PC_CURRENT_BRANCH_STATE               );
-    if (_param->_have_port_branch_update_prediction_id)
+    if (_param->_have_port_depth)
     PORT_WRITE(out_ADDRESS_BRANCH_UPDATE_PREDICTION_ID,reg_PC_CURRENT_BRANCH_UPDATE_PREDICTION_ID);
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_transition.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_transition.cpp	(revision 88)
@@ -22,5 +22,6 @@
   void Address_management::transition (void)
   {
-    log_printf(FUNC,Address_management,FUNCTION,"Begin");
+    log_begin(Address_management,FUNCTION);
+    log_function(Address_management,FUNCTION,_name.c_str());
 
     if (PORT_READ(in_NRESET) == 0)
@@ -28,5 +29,8 @@
 	// nothing is valid
 	reg_PC_CURRENT_VAL   = 0;
-	reg_PC_NEXT_VAL      = 0;
+
+        reg_PC_NEXT_VAL      = 1;
+        reg_PC_NEXT          = 0x100>>2;
+
 	reg_PC_NEXT_NEXT_VAL = 0;
       }
@@ -40,8 +44,8 @@
 	    for (uint32_t i=0; i<_param->_nb_instruction; i++)
 	    reg_PC_NEXT_INSTRUCTION_ENABLE [i] = PORT_READ(in_PREDICT_INSTRUCTION_ENABLE [i]);
-	    if (_param->_have_port_instruction_ptr)
+	    if (_param->_have_port_inst_ifetch_ptr)
 	    reg_PC_NEXT_INST_IFETCH_PTR             = PORT_READ(in_PREDICT_INST_IFETCH_PTR            );
 	    reg_PC_NEXT_BRANCH_STATE                = PORT_READ(in_PREDICT_BRANCH_STATE               );
-	    if (_param->_have_port_branch_update_prediction_id)
+	    if (_param->_have_port_depth)
 	    reg_PC_NEXT_BRANCH_UPDATE_PREDICTION_ID = PORT_READ(in_PREDICT_BRANCH_UPDATE_PREDICTION_ID);
 	    
@@ -51,5 +55,6 @@
 
 #ifdef STATISTICS
-	    (*_stat_nb_transaction_predict) ++;
+            if (usage_is_set(_usage,USE_STATISTICS))
+              (*_stat_nb_transaction_predict) ++;
 #endif
 	  }
@@ -62,12 +67,13 @@
 	  {
 #ifdef STATISTICS
-	    if (reg_PC_CURRENT_VAL)
-	      {
-		(*_stat_nb_transaction_address) ++;
-
-		for (uint32_t i=0; i<_param->_nb_instruction; i++)
-		  if (reg_PC_CURRENT_INSTRUCTION_ENABLE [i] == true)
-		    (*_stat_sum_packet_size) ++;
-	      }
+            if (usage_is_set(_usage,USE_STATISTICS))
+              if (reg_PC_CURRENT_VAL)
+                {
+                  (*_stat_nb_transaction_address) ++;
+                  
+                  for (uint32_t i=0; i<_param->_nb_instruction; i++)
+                    if (reg_PC_CURRENT_INSTRUCTION_ENABLE [i] == true)
+                      (*_stat_sum_packet_size) ++;
+                }
 #endif
 
@@ -110,5 +116,9 @@
 	if (PORT_READ(in_EVENT_VAL) and internal_EVENT_ACK)
 	  {
-	    log_printf(TRACE,Address_management,FUNCTION,"EVENT : Transaction");
+	    log_printf(TRACE,Address_management,FUNCTION,"  * EVENT : Transaction");
+	    log_printf(TRACE,Address_management,FUNCTION,"    * IS_DS_TAKE       : %d"  ,PORT_READ(in_EVENT_IS_DS_TAKE      ));
+	    log_printf(TRACE,Address_management,FUNCTION,"    * ADDRESS          : %.8x (%.8x)",PORT_READ(in_EVENT_ADDRESS         ),PORT_READ(in_EVENT_ADDRESS         )<<2);
+	    log_printf(TRACE,Address_management,FUNCTION,"    * ADDRESS_NEXT     : %.8x (%.8x)",PORT_READ(in_EVENT_ADDRESS_NEXT    ),PORT_READ(in_EVENT_ADDRESS_NEXT    )<<2);
+	    log_printf(TRACE,Address_management,FUNCTION,"    * ADDRESS_NEXT_VAL : %d"  ,PORT_READ(in_EVENT_ADDRESS_NEXT_VAL));
 	    reg_PC_CURRENT_VAL                      = 0;
 	    reg_PC_NEXT_VAL                         = 1;
@@ -118,26 +128,38 @@
 	    //  * load   miss speculation : the load is execute, the event_address is the next address (also the destination of branch)
 	    //  * exception               : goto the first instruction of exception handler (also is not in delay slot).
-	    reg_PC_NEXT_IS_DS_TAKE                  = 0;
+
+	    reg_PC_NEXT_IS_DS_TAKE                  = PORT_READ(in_EVENT_IS_DS_TAKE);
 // 	    reg_PC_NEXT_INST_IFETCH_PTR             = 0;
 // 	    reg_PC_NEXT_BRANCH_STATE                = BRANCH_STATE_NONE;
 // 	    reg_PC_NEXT_BRANCH_UPDATE_PREDICTION_ID = 0;
 	    
-// 	    reg_PC_NEXT_INSTRUCTION_ENABLE [0]      = 1; // only the instruction at the event address is valid, because we have no information on the branch presence in the instruction bundle.
-// 	    for (uint32_t i=1; i<_param->_nb_instruction; i++)
-// 	      reg_PC_NEXT_INSTRUCTION_ENABLE [i] = 0;
+	    reg_PC_NEXT_INSTRUCTION_ENABLE [0]      = 1; // only the instruction at the event address is valid, because we have no information on the branch presence in the instruction bundle.
+	    for (uint32_t i=1; i<_param->_nb_instruction; i++)
+	      reg_PC_NEXT_INSTRUCTION_ENABLE [i] = 0;
 
-	    reg_PC_NEXT_NEXT_VAL                    = 0; // cancel all prediction (event is send at the predict unit)
+            reg_PC_NEXT_NEXT_VAL                    = PORT_READ(in_EVENT_ADDRESS_NEXT_VAL);
+            reg_PC_NEXT_NEXT                        = PORT_READ(in_EVENT_ADDRESS_NEXT);
+            reg_PC_NEXT_NEXT_IS_DS_TAKE             = 0;//??
+
+            // Note : is_ds_take = address_next_val
+            // Because, is not ds take, can continue in sequence
+
+#ifdef DEBUG_TEST
+            if (PORT_READ(in_EVENT_ADDRESS_NEXT_VAL) and not PORT_READ(in_EVENT_IS_DS_TAKE))
+              throw ERRORMORPHEO(FUNCTION,_("Event : address_next_next_val but next is not a ds take"));
+#endif
 
 #ifdef STATISTICS
-	    (*_stat_nb_transaction_event) ++;
+            if (usage_is_set(_usage,USE_STATISTICS))
+              (*_stat_nb_transaction_event) ++;
 #endif
 	  }
       }
 
-#if DEBUG >= DEBUG_TRACE
-    log_printf(TRACE,Address_management,FUNCTION,"Address_Management : ");
-    log_printf(TRACE,Address_management,FUNCTION,"Current   : %d %d 0x%x",reg_PC_CURRENT_VAL, reg_PC_CURRENT_IS_DS_TAKE, reg_PC_CURRENT);
-    log_printf(TRACE,Address_management,FUNCTION,"Next      : %d %d 0x%x",reg_PC_NEXT_VAL, reg_PC_NEXT_IS_DS_TAKE, reg_PC_NEXT);    
-    log_printf(TRACE,Address_management,FUNCTION,"Next_Next : %d %d 0x%x",reg_PC_NEXT_NEXT_VAL, reg_PC_NEXT_NEXT_IS_DS_TAKE, reg_PC_NEXT_NEXT);    
+#if defined(DEBUG) and (DEBUG >= DEBUG_TRACE)
+    log_printf(TRACE,Address_management,FUNCTION,"  * Dump PC");
+    log_printf(TRACE,Address_management,FUNCTION,"    * Current   : %d %d 0x%.8x (%.8x)",reg_PC_CURRENT_VAL  , reg_PC_CURRENT_IS_DS_TAKE  , reg_PC_CURRENT  , reg_PC_CURRENT  <<2);
+    log_printf(TRACE,Address_management,FUNCTION,"    * Next      : %d %d 0x%.8x (%.8x)",reg_PC_NEXT_VAL     , reg_PC_NEXT_IS_DS_TAKE     , reg_PC_NEXT     , reg_PC_NEXT     <<2);    
+    log_printf(TRACE,Address_management,FUNCTION,"    * Next_Next : %d %d 0x%.8x (%.8x)",reg_PC_NEXT_NEXT_VAL, reg_PC_NEXT_NEXT_IS_DS_TAKE, reg_PC_NEXT_NEXT, reg_PC_NEXT_NEXT<<2);    
 #endif 
 
@@ -145,6 +167,6 @@
     end_cycle ();
 #endif
-
-    log_printf(FUNC,Address_management,FUNCTION,"End");
+    
+    log_end(Address_management,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Parameters.cpp	(revision 88)
@@ -21,18 +21,25 @@
   Parameters::Parameters (uint32_t nb_instruction,
 			  uint32_t size_address  ,
-			  uint32_t size_branch_update_prediction)
+			  uint32_t size_branch_update_prediction,
+                          bool     is_toplevel)
   {
     log_printf(FUNC,Address_management,FUNCTION,"Begin");
 
-    _nb_instruction                        = nb_instruction               ;
-    _size_address                          = size_address                 ;
-    _size_branch_update_prediction         = size_branch_update_prediction;
-
-    _size_instruction_ptr                  = log2(nb_instruction);
-
-    _have_port_instruction_ptr             = _size_instruction_ptr > 0;
-    _have_port_branch_update_prediction_id = size_branch_update_prediction > 0;
+    _nb_instruction = nb_instruction               ;
 
     test();
+
+    if (is_toplevel)
+      {
+        _size_instruction_address  = size_address                 ;
+        _size_depth                = size_branch_update_prediction;
+        _size_inst_ifetch_ptr      = log2(nb_instruction);
+        
+        _have_port_inst_ifetch_ptr = _size_inst_ifetch_ptr > 0;
+        _have_port_depth           = _size_depth > 0;
+
+        copy();
+      }
+
     log_printf(FUNC,Address_management,FUNCTION,"End");
   };
@@ -55,4 +62,12 @@
   };
 
+#undef  FUNCTION
+#define FUNCTION "Address_management::copy"
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Address_management,FUNCTION,"Begin");
+    log_printf(FUNC,Address_management,FUNCTION,"End");
+  };
+
 }; // end namespace address_management
 }; // end namespace ifetch_unit
